#include "define.h"

static char *version[1] = {"Mar 30,1993"};

NiFU(m,x,y)
int m,x,y;
{
  int i;
  if ((Mochigoma1[m] < KEI1 && (y == 0)) || 
    (Mochigoma1[m] == KEI1 && (y < 2))) return TRUE;
  if (Mochigoma1[m] != FU1) return FALSE;
  for (i=0;i<9;i++) {
    if (Board[i][x] == FU1)
      return TRUE;
  }
  return FALSE;
}

NiFU2(m,x,y)
int m,x,y;
{
  int i;
  if ((Mochigoma2[m] < KEI2 && (y == 8)) ||
    (Mochigoma2[m] == KEI2 && (y > 6))) return TRUE;
  if (Mochigoma2[m] != FU2) return FALSE;
  for (i=0;i<9;i++) {
    if (Board[i][x] == FU2)
      return TRUE;
  }
  return FALSE;
}

CheckMovePossible2(x0,y0,x,y)
int x0,y0,x,y;
{
  int i;
  switch(Board[y0][x0]){
    case FU2:
      if (x!=x0 || y!=y0+1) return FALSE;
      break;
    case GYO2:
      if (x != x0 || y < y0) return FALSE;
      else {
        for (i=1;y > y0 + i;i++) 
          if (Board[y0 + i][x0] != 0) return FALSE;
      }
      break;
    case KEI2:
      if (y==y0+2 && (x==x0+1||x==x0-1)) break;
      return FALSE;
    case GIN2:
      if ((x==x0&&y==y0+1)||(x==x0+1&&y==y0+1)||(x==x0-1&&y==y0+1)
         ||(x==x0-1&&y==y0-1)||(x==x0+1&&y==y0-1)) break;
      return FALSE;
    case KAKU2:
      if (abs(y-y0)!=abs(x-x0)) return FALSE;
      else {
        for (i=1;y<y0-i && x<x0-i;i++)
          if (Board[y0 - i][x0 - i] != 0) return FALSE;
        for (i=1;y<y0-i && x>x0+i;i++)
          if (Board[y0 - i][x0 + i] != 0) return FALSE;
        for (i=1;y>y0+i && x<x0-i;i++)
          if (Board[y0 + i][x0 - i] != 0) return FALSE;
        for (i=1;y>y0+i && x>x0+i;i++)
          if (Board[y0 + i][x0 + i] != 0) return FALSE;
      }
      break;
    case HISHA2:
      if (x!=x0 && y!=y0) return FALSE;
      else {
        for (i=1;y < y0 - i;i++)
          if (Board[y0 - i][x] != 0) return FALSE;
        for (i=1;y > y0 + i;i++)
          if (Board[y0 + i][x] != 0) return FALSE;
        for (i=1;x < x0 - i;i++)
          if (Board[y][x0 - i] != 0) return FALSE;
        for (i=1;x > x0 + i;i++)
          if (Board[y][x0 + i] != 0) return FALSE;
        break;
      }
    case NKAKU2:
      if (abs(y-y0)!=abs(x-x0) && (abs(x-x0)>1 || abs(y-y0)>1)) return FALSE;
      if (abs(y-y0)!=abs(x-x0) && abs(x-x0) == 1 && abs(y-y0) == 1) break;
      else {
        for (i=1; y < y0 - i && x < x0 - i;i++)
          if (Board[y0 - i][x0 - i] != 0) return FALSE;
        for (i=1; y < y0 - i && x > x0 + i;i++)
          if (Board[y0 - i][x0 + i] != 0) return FALSE;
        for (i=1; y > y0 + i && x < x0 - i;i++)
          if (Board[y0 + i][x0 - i] != 0) return FALSE;
        for (i=1; y > y0 + i && x > x0 + i;i++)
          if (Board[y0 + i][x0 + i] != 0) return FALSE;
      }
      break;
    case NHISHA2:
      if (x!=x0 && y!=y0 && (abs(x-x0) > 1 || abs(y-y0) > 1)) return FALSE;
      if (x!=x0 && y!=y0 && abs(x-x0) == 1 && abs(y-y0) == 1) break;
      else {
        for (i=1;y < y0 - i;i++)
          if (Board[y0 - i][x] != 0) return FALSE;
        for (i=1;y > y0 + i;i++)
          if (Board[y0 + i][x] != 0) return FALSE;
        for (i=1;x < x0 - i;i++)
          if (Board[y][x0 - i] != 0) return FALSE;
        for (i=1;x > x0 + i;i++)
          if (Board[y][x0 + i] != 0) return FALSE;
      }
      break;
    case KIN2: case NFU2: case NGYO2: case NKEI2: case NGIN2:
      if ((x==x0&&y==y0+1)||(x==x0-1&&y==y0+1)||(x==x0-1&&y==y0)
         ||(x==x0&&y==y0-1)||(x==x0+1&&y==y0+1)||(x==x0+1&&y==y0)) break;
      return FALSE;
    case OO2:
      if ((x==x0&&y==y0-1)||(x==x0-1&&y==y0-1)||(x==x0+1&&y==y0+1)
          ||(x==x0&&y==y0+1)||(x==x0-1&&y==y0+1)||(x==x0+1&&y==y0-1)
          ||(x==x0-1&&y==y0)||(x==x0+1&&y==y0)) break;
      return FALSE;
  }
  return TRUE;
}

CheckMovePossible(x0,y0,x,y)
int x0,y0,x,y;
{
  int i;
  switch(Board[y0][x0]){
    case FU1:
      if (x!=x0 || y!=y0-1) return FALSE;
      break;
    case GYO1:
      if (x != x0 || y > y0) return FALSE;
      else {
        for (i=1;y < y0 - i;i++)
          if (Board[y0 - i][x0] != 0) return FALSE;
      }
      break;
    case KEI1:
      if (y==y0-2 && (x==x0+1||x==x0-1)) break;
      return FALSE;
    case GIN1:
      if ((x==x0&&y==y0-1)||(x==x0+1&&y==y0-1)||(x==x0-1&&y==y0-1)
         ||(x==x0-1&&y==y0+1)||(x==x0+1&&y==y0+1)) break;
      return FALSE;
    case KAKU1:
      if (abs(y-y0)!=abs(x-x0)) return FALSE;
      else {
        for (i=1;y<y0-i && x<x0-i;i++)
          if (Board[y0 - i][x0 - i] != 0) return FALSE;
        for (i=1;y<y0-i && x>x0+i;i++)
          if (Board[y0 - i][x0 + i] != 0) return FALSE;
        for (i=1;y>y0+i && x<x0-i;i++)
          if (Board[y0 + i][x0 - i] != 0) return FALSE;
        for (i=1;y>y0+i && x>x0+i;i++)
          if (Board[y0 + i][x0 + i] != 0) return FALSE;
      }
      break;
    case HISHA1:
      if (x!=x0 && y!=y0) return FALSE;
      else {
        for (i=1;y < y0 - i;i++)
          if (Board[y0 - i][x] != 0) return FALSE;
        for (i=1;y > y0 + i;i++)
          if (Board[y0 + i][x] != 0) return FALSE;
        for (i=1;x < x0 - i;i++)
          if (Board[y][x0 - i] != 0) return FALSE;
        for (i=1;x > x0 + i;i++)
          if (Board[y][x0 + i] != 0) return FALSE;
        break;
      }
    case NKAKU1:
      if (abs(y-y0)!=abs(x-x0) && (abs(x-x0)>1 || abs(y-y0)>1)) return FALSE;
      if (abs(y-y0)!=abs(x-x0) && abs(x-x0) == 1 && abs(y-y0) == 1) break;
      else {
        for (i=1; y < y0 - i && x < x0 - i;i++)
          if (Board[y0 - i][x0 - i] != 0) return FALSE;
        for (i=1; y < y0 - i && x > x0 + i;i++)
          if (Board[y0 - i][x0 + i] != 0) return FALSE;
        for (i=1; y > y0 + i && x < x0 - i;i++)
          if (Board[y0 + i][x0 - i] != 0) return FALSE;
        for (i=1; y > y0 + i && x > x0 + i;i++)
          if (Board[y0 + i][x0 + i] != 0) return FALSE;
      }
      break;
    case NHISHA1:
      if (x!=x0 && y!=y0 && (abs(x-x0) > 1 || abs(y-y0) > 1)) return FALSE;
      if (x!=x0 && y!=y0 && abs(x-x0) == 1 && abs(y-y0) == 1) break;
      else {
        for (i=1;y < y0 - i;i++)
          if (Board[y0 - i][x] != 0) return FALSE;
        for (i=1;y > y0 + i;i++)
          if (Board[y0 + i][x] != 0) return FALSE;
        for (i=1;x < x0 - i;i++)
          if (Board[y][x0 - i] != 0) return FALSE;
        for (i=1;x > x0 + i;i++)
          if (Board[y][x0 + i] != 0) return FALSE;
      }
      break;
    case KIN1: case NFU1: case NGYO1: case NKEI1: case NGIN1:
      if ((x==x0&&y==y0-1)||(x==x0-1&&y==y0-1)||(x==x0-1&&y==y0)
         ||(x==x0&&y==y0+1)||(x==x0+1&&y==y0-1)||(x==x0+1&&y==y0)) break;
      return FALSE;
    case OO1:
      if ((x==x0&&y==y0-1)||(x==x0-1&&y==y0-1)||(x==x0+1&&y==y0+1)
          ||(x==x0&&y==y0+1)||(x==x0-1&&y==y0+1)||(x==x0+1&&y==y0-1)
          ||(x==x0-1&&y==y0)||(x==x0+1&&y==y0)) break;
      return FALSE;
  }
  return TRUE;
}


GetArgs(argc, argv)
int argc;
char **argv;
{
  int count, flag = FALSE;
  strcpy(TIME ,"10");
  strcpy(TIME1,"10");
  strcpy(TIME2,"30");
  strcpy(TIME3,"30");
  if (argc < 2) return FALSE;
  for (count = 1; count < argc; count++) {
    if (argv[count][0] != '-') {
      strcpy(DISPLAY, argv[count]);
      flag = TRUE;
    } else if ((strcmp("-display", argv[count]) == 0) && (count + 1 < argc)) {
      strcpy(DISPLAY, argv[++count]);
      flag = TRUE;
    } else if ((strcmp("-load", argv[count]) == 0) && (count + 1 < argc)) 
      strcpy(FILENAME, argv[++count]);
    else if (strcmp("-first", argv[count]) == 0) IFIRST = 2;
    else if ((strcmp("-time", argv[count]) == 0) && (count + 1 < argc)) {
      strcpy(TIME1, argv[++count]);
      if ((count+1 < argc) && 
	  (argv[count+1][0] >= '0') && (argv[count+1][0] <= '9'))
	strcpy(TIME, argv[++count]);
      else strcpy(TIME, TIME1);
    }
    else if ((strcmp("-time2", argv[count]) == 0) && (count + 1 < argc)) {
      strcpy(TIME3, argv[++count]);
      if ((count+1 < argc) &&
	  (argv[count+1][0] >= '0') && (argv[count+1][0] <= '9')) 
	strcpy(TIME2, argv[++count]);
      else strcpy(TIME2, TIME3);
    }
    else if (strcmp("-nobell", argv[count]) == 0) BELL = FALSE;
    else if (strcmp("-noohte", argv[count]) == 0) NOOHTE = TRUE;
    else if (strcmp("-notsumi", argv[count]) == 0) NOTSUMI = TRUE;
    else if ((strcmp("-ochi1", argv[count]) == 0) && (count + 1 < argc)) {
      if (argv[++count][6] != '\0') return FALSE;
      Ochi1(argv[count]);
    }
    else if ((strcmp("-ochi2", argv[count]) == 0) && (count + 1 < argc)) {
      if (argv[++count][6] != '\0') return FALSE;
      Ochi2(argv[count]);
    }
    else if (strcmp("-nomatta", argv[count]) == 0) NOMATTA = TRUE;
    else if (strcmp("-noname", argv[count]) == 0) NONAME = TRUE;
    else if (strcmp("-formal", argv[count]) == 0) {
      NOMATTA = TRUE;  NOOHTE = TRUE;
    }
  }
  if (flag == FALSE) return FALSE;
  return TRUE;
}

Ochi2(string)
char string[];
{
  int i;
  if (string[0] == '0') Board[8][0] = 0;
  if (string[1] == '0') Board[8][1] = 0;
  if (string[2] == '0') Board[7][1] = 0;
  if (string[3] == '0') Board[7][7] = 0;
  if (string[4] == '0') Board[8][7] = 0;
  if (string[5] == '0') Board[8][8] = 0;
}

Ochi1(string)
char string[];
{
  int i;
  if (string[0] == '0') Board[0][8] = 0;
  if (string[1] == '0') Board[0][7] = 0;
  if (string[2] == '0') Board[1][7] = 0;
  if (string[3] == '0') Board[1][1] = 0;
  if (string[4] == '0') Board[0][1] = 0;
  if (string[5] == '0') Board[0][0] = 0;
}

PrintArg()
{
  printf("----- 2way SHOGI (x2shogi) %s -----\n",version[0]);
  printf("Usage  : x2shogi <your opponent's DISPLAY> (eg maxwell.elec:0)\n");
  printf("Option :\n");
  printf("   -load     FILENAME (To restore the last state)\n");
  printf("   -first    (To take the first move)\n");
  printf("   -time     YOURS (OPPONENT's) (Upto 60 min ");
  printf("(eg -time 10 or -time 10 15))\n");
  printf("   -time2    YOURS (OPPONENT's) (After time used. Upto 60 sec)\n");
  printf("   -ochi1    (To drop your komas       GyoKeiKakuHishaKeiKyo");
  printf(" (eg 110011))\n");
  printf("   -ochi2    (To drop opponent's komas GyoKeiKakuHishaKeiKyo");
  printf(" (eg 110011))\n");
  printf("   -nobell   (Not to ring a bell)\n");
  printf("   -nomatta  (To be unable to matta)\n");
  printf("   -noname   (Not to print your name in your opponent's display)\n");
  printf("   -noohte   (Not to ring bells when your kings are in danger)\n");
  printf("   -notsumi  (Not to end when you can't prevent the capture of");
  printf(" your kings)\n");
  printf("   -formal   (-nomatta and -noohte)\n");
  exit(1);
}

PrintTitle()
{
  printf("------------------------------------------------------\n");
  printf("------------------------------------------------------\n");
  printf("---------------- 2 w a y  S H O G I ------------------\n");
  printf("------------------------------------------------------\n");
  printf("----- Copyright (C) %s - Yusaku Okamura -----\n",version[0]);
  printf("------------------------------------------------------\n");
  printf("--- If you find any trouble, please mail it to me. ---\n");
  printf("--------- I will fix it in a next version. -----------\n");
  printf("------------------------------------------------------\n");
  printf("--------- E-mail:t20520@ee.t.u-tokyo.ac.jp -----------\n");
  printf("------------------------------------------------------\n");
  printf("-- This software comes with absolutely NO WARRANTY. --\n");
  printf("------------------------------------------------------\n");
  printf("------------------------------------------------------\n");
}

CheckInB(x,y)
int x,y;
{
  if ((x >= 0) && (x < 9) && (y >= 0) && (y < 9)) return TRUE;
  else return FALSE;
}

CheckFriend(x,y)
int x,y;
{
  int b = Board[y][x];
  if (b < 20 && b > 0) return TRUE;
  else return FALSE;
}

CheckFriend2(x,y)
int x,y;
{
  int b = Board[y][x];
  if (b < 40 && b > 20) return TRUE;
  else return FALSE;
}

CheckInM(x,y)
int x,y;
{
  if ((x >= 630 && x <= 780) && (y >= 190 && y <= 490) &&
      (Mochigoma1[BtoM(x,y)] != 0)) return TRUE;
  else return FALSE;
} 

CheckInM2(x,y)
int x,y;
{
  if ((x >= 630 && x <= 780) && (y >= 190 && y <= 490) &&
      Mochigoma2[BtoM(x,y)] != 0) return TRUE;
  else return FALSE;
}

/* Board to Mochigoma number */
BtoM(x,y)
{
  return ((x-30)/50-12)*6+(y+10)/50-4;
}

/* xy to Board */
XtoB(x)
int x;
{
  return (x-20)/50-3;
}

YtoB(y)
int y;
{
  return (y+10)/50-1;
}

Uchifuzume(n,mu,xu,yu)
int n,mu,xu,yu;
{
  int i,j,B[9][9];
  if (n == 1) {
    if (Mochigoma1[mu] != FU1) return FALSE;
    if (CheckTsumi(2,Board) == TRUE) return FALSE;
    for (j=0;j<9;j++)
      for (i=0;i<9;i++)
        B[j][i] = Board[j][i];
    B[yu][xu] = FU1;
    return CheckTsumi(2,B);
  } else {
    if (Mochigoma2[mu] != FU2) return FALSE;
    if (CheckTsumi(1,Board) == TRUE) return FALSE;
    for (j=0;j<9;j++)
      for (i=0;i<9;i++)
        B[j][i] = Board[j][i];
    B[yu][xu] = FU2;
    return CheckTsumi(1,B);
  }
}
