#include "main.h"
#include "komabitmaps"
#include <stdio.h>
#include <pwd.h>

static int line_x1[40] ={170,170,170,170,170,170,170,170,170,170,
	        170,220,270,320,370,420,470,520,570,620,
		10,10,160,160,630,630,780,780,
		9,9,161,161,629,629,781,781,
		169,169,621,621},
  line_x2[40] ={620,620,620,620,620,620,620,620,620,620,
	        170,220,270,320,370,420,470,520,570,620,
		160,10,160,10,780,630,780,630,
		161,9,161,9,781,629,781,629,
		621,169,621,169},
  line_y1[40] ={40,90,140,190,240,290,340,390,440,490,
                40,40,40,40,40,40,40,40,40,40,
		40,40,340,340,190,190,490,490,
		39,39,341,341,189,189,491,491,
		39,39,491,491},
  line_y2[40] = {40,90,140,190,240,290,340,390,440,490,
                490,490,490,490,490,490,490,490,490,490,
		40,340,40,340,190,490,190,490,
		39,341,39,341,189,491,189,491,
		39,491,39,491};

DrawLine()
{
  int i;
  for (i=0;i<40;i++) {
    XDrawLine(d, win[0], gc, line_x1[i], line_y1[i], line_x2[i], line_y2[i]);
  }
}

DrawLine2()
{
  int i;
  for (i=0;i<40;i++) {
    XDrawLine(d2,win2[0],gc2,line_x1[i], line_y1[i], line_x2[i], line_y2[i]);
  }
}

CreatePixmap(n,w)
int n,w;
{
  pixmap  = XCreatePixmapFromBitmapData(d, win[w],
     bits[n], koma_width, koma_height, fg, bg, dd);
  XSetWindowBackgroundPixmap(d, win[w], pixmap);
  XClearWindow(d, win[w]);
}

CreatePixmap2(n,w)
int n,w;
{
  pixmap  = XCreatePixmapFromBitmapData(d2, win2[w],
     bits2[n], koma_width, koma_height, fg2, bg2, dd2);
  XSetWindowBackgroundPixmap(d2, win2[w], pixmap);
  XClearWindow(d2, win2[w]);
}

/* Create Koma in the *d */
/* Create Koma in the *d2 */
Create_Koma()
{
 Window root, child;
 int i,j,rx, ry, wx, wy, winno = 1;
 unsigned int mask;
 for (i=0;i<9;i++){
   for (j=0;j<9;j++){
     if (Board[j][i] != 0) {
       BoardW[j][i] = winno++;
       win[BoardW[j][i]] = XCreateSimpleWindow(d, win[0], 
         175+i*50, 45+j*50, koma_width, koma_height, 0, fg, bg);
       CreatePixmap(Board[j][i],BoardW[j][i]);
       XSelectInput(d, win[BoardW[j][i]], 0);

       win2[BoardW[j][i]] = XCreateSimpleWindow(d2, win2[0], 
         575-i*50, 445-j*50, koma_width, koma_height, 0, fg2, bg2);
       CreatePixmap2(Board[j][i],BoardW[j][i]);
       XSelectInput(d2, win2[BoardW[j][i]], 0);
     }
   }
 }

OpenYN(1);

/* func */
 for (i=0;i<3;i++){
   win[i+43] = XCreateSimpleWindow(d, win[0], 645+i*50, 155,
              func_width, func_height, 0, fg, bg);
   pixmap  = XCreatePixmapFromBitmapData(d, win[i+43], 
                 func_bits[i], func_width, func_height, fg, bg, dd);
   XSetWindowBackgroundPixmap(d, win[i+43], pixmap);
   XSelectInput(d, win[i+43],
		ButtonPressMask | EnterWindowMask | LeaveWindowMask);
   XMapSubwindows(d, win[0]);
 }
 if (NOMATTA == TRUE) XMoveWindow(d, win[43], 1000, 0);
/* hand 
 XQueryPointer(d2, win2[0], &root, &child, &rx, &ry, &wx, &wy, &mask);
 win[46] = XCreateSimpleWindow(d, win[0], wx, wy,
              func_width, func_height, 0, fg, bg);
 pixmap  = XCreatePixmapFromBitmapData(d, win[46], 
                 func_bits[0], func_width, func_height, fg, bg, dd);
 XSetWindowBackgroundPixmap(d, win[46], pixmap);
 XSelectInput(d, win[46], 0);
 XMapSubwindows(d, win[0]);*/

OpenYN(2);

/* func */
 for (i=0;i<3;i++){
   win2[i+43] = XCreateSimpleWindow(d2, win2[0], 645+i*50, 155,
                 func_width, func_height, 0, fg2, bg2);
   pixmap  = XCreatePixmapFromBitmapData(d2, win2[i+43],
                 func_bits[i], func_width, func_height, fg2, bg2, dd2);
   XSetWindowBackgroundPixmap(d2, win2[i+43], pixmap);
   XSelectInput(d2, win2[i+43],
                ButtonPressMask | EnterWindowMask | LeaveWindowMask);
   XMapSubwindows(d2, win2[0]);
 }
 if (NOMATTA == TRUE) XMoveWindow(d2, win2[43], 1000, 0);
/* hand 
 XQueryPointer( d, win[0], &root, &child, &rx, &ry, &wx, &wy, &mask);
 win2[46] = XCreateSimpleWindow(d2, win2[0], wx, wy,
              func_width, func_height, 0, fg, bg);
 pixmap  = XCreatePixmapFromBitmapData(d2, win2[46], 
              func_bits[0], func_width, func_height, fg, bg, dd);
 XSetWindowBackgroundPixmap(d2, win2[46], pixmap);
 XSelectInput(d2, win2[46], 0);
 XMapSubwindows(d2, win2[0]);*/

/* Create Mochigoma in the *d */
/* Create Mochigoma in the *d2 */
 for (i=0;i<18;i++){
     if (Mochigoma1[i] != 0) {
       Mochigoma1W[i] = winno++;
       win[Mochigoma1W[i]] = XCreateSimpleWindow(d, win[0], 
         635+i/6*50, 195+i%6*50, koma_width, koma_height, 0, fg, bg);
       CreatePixmap(Mochigoma1[i],Mochigoma1W[i]);
       XSelectInput(d, win[Mochigoma1W[i]], 0);

       win2[Mochigoma1W[i]] = XCreateSimpleWindow(d2, win2[0], 
         115-i/6*50, 295-i%6*50, koma_width, koma_height, 0, fg2, bg2);
       CreatePixmap2(Mochigoma1[i],Mochigoma1W[i]);
       XSelectInput(d2, win2[Mochigoma1W[i]], 0);
     }
     if (Mochigoma2[i] != 0) {
       Mochigoma2W[i] = winno++;
       win[Mochigoma2W[i]] = XCreateSimpleWindow(d, win[0], 
         115-i/6*50, 295-i%6*50, koma_width, koma_height, 0, fg, bg);
       CreatePixmap(Mochigoma2[i],Mochigoma2W[i]);
       XSelectInput(d, win[Mochigoma2W[i]], 0);

       win2[Mochigoma2W[i]] = XCreateSimpleWindow(d2, win2[0], 
         635+i/6*50, 195+i%6*50, koma_width, koma_height, 0, fg2, bg2);
       CreatePixmap2(Mochigoma2[i],Mochigoma2W[i]);
       XSelectInput(d2, win2[Mochigoma2W[i]], 0);
     }
 }
 for (i=18;i<40;i++){
     if (Mochigoma1[i] != 0) {
       Mochigoma1W[i] = winno++;
       win[Mochigoma1W[i]] = XCreateSimpleWindow(d, win[0], 
         1000, 0, koma_width, koma_height, 0, fg, bg);
       CreatePixmap(Mochigoma1[i],Mochigoma1W[i]);
       XSelectInput(d, win[Mochigoma1W[i]], 0);

       win2[Mochigoma1W[i]] = XCreateSimpleWindow(d2, win2[0], 
         1000, 0, koma_width, koma_height, 0, fg2, bg2);
       CreatePixmap2(Mochigoma1[i],Mochigoma1W[i]);
       XSelectInput(d2, win2[Mochigoma1W[i]], 0);
     }
     if (Mochigoma2[i] != 0) {
       Mochigoma2W[i] = winno++;
       win[Mochigoma2W[i]] = XCreateSimpleWindow(d, win[0], 
         1000, 0, koma_width, koma_height, 0, fg, bg);
       CreatePixmap(Mochigoma2[i],Mochigoma2W[i]);
       XSelectInput(d, win[Mochigoma2W[i]], 0);

       win2[Mochigoma2W[i]] = XCreateSimpleWindow(d2, win2[0], 
         1000, 0, koma_width, koma_height, 0, fg2, bg2);
       CreatePixmap2(Mochigoma2[i],Mochigoma2W[i]);
       XSelectInput(d2, win2[Mochigoma2W[i]], 0);
     }
 }
 XMapSubwindows(d, win[0]);
 XMapSubwindows(d2, win2[0]);

 if (Tnx != 99) koma = BoardW[Tny][Tnx];
}

Check0(s)
char *s;
{
  int i = 0;

  while (s[i] != '\0') 
    if (s[i++] == ':') return TRUE;
  return FALSE;
}

/* Open Diplay 1 */
Open_Display()
{
 struct passwd *pass;
 char name[50];
 if (DISPLAY[0] != '\0'&& Check0(DISPLAY) == FALSE) strcat(DISPLAY,":0.0");
 if ((d = XOpenDisplay(DISPLAY)) == NULL) {
   printf("The DISPLAY doesn't exist.\n");
   exit(1);
 }
 if ((font = XLoadQueryFont(d, FONTNAME)) == NULL) {
   if ((font = XLoadQueryFont(d, "fixed")) == NULL) {
     printf("The DISPLAY doesn't have FONT 'fixed'.");
     exit(1);
   }
 }
 bg = WhitePixel(d, DefaultScreen(d));
 fg = BlackPixel(d, DefaultScreen(d));
 dd = DefaultDepth(d, DefaultScreen(d));

 win[0] = XCreateSimpleWindow(d, DefaultRootWindow(d),
                      0, 0, screen_width, screen_height, 1, fg, bg);
 iconwin = XCreateSimpleWindow(d, DefaultRootWindow(d),
		      0, 0, icon_width, icon_height, 2, fg, bg);

 XSelectInput(d, win[0], ExposureMask | ButtonPressMask);

 gcv.font = font->fid; gcv.foreground = fg; gcv.background = bg;
 gc = XCreateGC(d, win[0], GCFont | GCForeground | GCBackground, &gcv);
       
 gcvb.font = font->fid; gcvb.foreground = bg; gcvb.background = fg;
 gcb = XCreateGC(d, win[0], GCFont | GCForeground | GCBackground, &gcvb);
 
 XMapWindow(d, win[0]);

 wmhints = XAllocWMHints();
 pixmap  = XCreatePixmapFromBitmapData(d, win[0],
		icon_bits, icon_width, icon_height, bg, fg, dd);

 XSetWindowBackgroundPixmap(d,iconwin,pixmap);
 wmhints->flags=IconPixmapHint|IconWindowHint;
 wmhints->icon_pixmap=pixmap;
 wmhints->icon_window=iconwin;
 XSetWMHints(d,win[0],wmhints);
 
 if (NONAME == FALSE) {
   strcpy(name,"2way SHOGI from ");
   pass = getpwnam((char *)cuserid(NULL));
   strcat(name,pass->pw_name);
   strcat(name,"(");
   strcat(name,pass->pw_gecos);
   strcat(name,")@");
   strcat(name,getenv("DISPLAY"));
 } else strcpy(name,"2way SHOGI");
 XStoreName(d, win[0], name);
 XDefineCursor(d, win[0], XCreateFontCursor(d, 58));
 XFlush(d);
}

/* Open Display 2 */
Open_Display2()
{
 char name[30];
 if ((d2 = XOpenDisplay(NULL)) == NULL) exit(1);
 if ((font2 = XLoadQueryFont(d2, FONTNAME)) == NULL) {
   if ((font2 = XLoadQueryFont(d2, "fixed")) == NULL) {
     printf("Your display doesn't have FONT 'fixed'.");
     exit(1);
   }
 }

 bg2 = WhitePixel(d2, DefaultScreen(d2));
 fg2 = BlackPixel(d2, DefaultScreen(d2));
 dd2 = DefaultDepth(d2, DefaultScreen(d2));

 win2[0] = XCreateSimpleWindow(d2, DefaultRootWindow(d2),
                      0, 0, screen_width, screen_height, 1, fg2, bg2);
 iconwin2 = XCreateSimpleWindow(d2, DefaultRootWindow(d2), 
				0, 0, icon_width, icon_height, 2, fg2, bg2);

 XSelectInput(d2, win2[0], ExposureMask | ButtonPressMask);

 gcv2.font = font2->fid; gcv2.foreground = fg2; gcv2.background = bg2;
 gc2 = XCreateGC(d2, win2[0], GCFont | GCForeground | GCBackground, &gcv2);

 gcvb2.font = font2->fid; gcvb2.foreground = bg2; gcvb2.background = fg2;
 gcb2 = XCreateGC(d2, win2[0], GCFont | GCForeground | GCBackground, &gcvb2);

 XMapWindow(d2, win2[0]);

 wmhints2 = XAllocWMHints();
 pixmap  = XCreatePixmapFromBitmapData(d2, win2[0],
		icon_bits, icon_width, icon_height, fg2, bg2, dd2);

 XSetWindowBackgroundPixmap(d2,iconwin2,pixmap);
 wmhints2->flags=IconPixmapHint|IconWindowHint;
 wmhints2->icon_pixmap=pixmap;
 wmhints2->icon_window=iconwin2;
 XSetWMHints(d2,win2[0],wmhints2);

 strcpy(name,"2way SHOGI to @");
 strcat(name,DISPLAY);
 XStoreName(d2, win2[0], name);
 XDefineCursor(d2, win2[0], XCreateFontCursor(d2, 60));
 XFlush(d2);
}
