#include <signal.h>
#include "main.h"

static char *message[2] = {"YOURS","HIS"};

TimeCount1()
{
  signal(SIGALRM, SIG_IGN);
  while (XEventsQueued(d2, QueuedAfterFlush) != 0) {
    XNextEvent(d2, &event2);
    switch(event2.type) {
     case Expose:
      DrawLine2();
      WindowPick(koma);
      ExposePrintMessage2(1);
      ExposePrintTime2();
      break;
    }
  } 
  if (Time1 == 0 && TimeAfter1 == 0) Win(8);
  if (Time1 == 0) {
    if (TimeAfter1 < 11 && BELL) XBell(d, 100);
    PrintTime1(--TimeAfter1);
  } else {
    if (TimeAfter1 == 0 && Time1 < 11 && BELL) XBell(d, 100);
    PrintTime1(--Time1);
  }
  alarm(1);
  signal(SIGALRM,TimeCount1);
  return TRUE;
}

TimeCount2()
{
  signal(SIGALRM, SIG_IGN);
  while (XEventsQueued(d, QueuedAfterFlush) != 0) {
    XNextEvent(d, &event);
    switch(event.type) {
     case Expose:
      DrawLine();
      WindowPick(koma);
      ExposePrintMessage(1);
      ExposePrintTime1();
      break;
    }
  } 
  if (Time2 == 0 && TimeAfter2 == 0) Win(7);
  if (Time2 == 0) {
    if (TimeAfter2 < 11 && BELL) XBell(d2, 100);
    PrintTime2(--TimeAfter2);
  } else {
    if (TimeAfter2 == 0 && Time2 < 11 && BELL) XBell(d, 100);
    PrintTime2(--Time2);
  }
  alarm(1);
  signal(SIGALRM,TimeCount2);
  return TRUE;
}

MoveHand1()
{
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;
  XQueryPointer(d2, win2[0], &root, &child, &rx, &ry, &wx, &wy, &mask);
  XMoveWindow( d, win[45], wx, wy);
}

MoveHand2()
{
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;
  XQueryPointer( d, win[0], &root, &child, &rx, &ry, &wx, &wy, &mask);
  XMoveWindow(d2, win2[45], wx, wy);
}

ExposePrintTime1()
{
  char str[5];
  int i;
  if (Time1 == 0) i = TimeAfter1; else i = Time1;
  XDrawString(d,win[0],gc,YOURSx,YOURSy,message[0],strlen(message[0]));
  Sec2Clock(str, i);  
  if (Time1 == 0) str[2] = ' ';
  XDrawString(d,win[0],gc,YOURStx,YOURSty,str,strlen(str));
  if (Time2 == 0) i = TimeAfter2; else i = Time2;
  XDrawString(d,win[0],gc,HISx,HISy,message[1],strlen(message[1]));
  Sec2Clock(str, i);  
  if (Time2 == 0) str[2] = ' ';
  XDrawString(d,win[0],gc,HIStx,HISty,str,strlen(str));
  XFlush(d);
}

ExposePrintTime2()
{
  char str[5];
  int i;
  if (Time2 == 0) i = TimeAfter2; else i = Time2;
  XDrawString(d2,win2[0],gc2,YOURSx,YOURSy,message[0],strlen(message[0]));
  Sec2Clock(str, i);  
  if (Time2 == 0) str[2] = ' ';
  XDrawString(d2,win2[0],gc2,YOURStx,YOURSty,str,strlen(str));
  if (Time1 == 0) i = TimeAfter1; else i = Time1;
  XDrawString(d2,win2[0],gc2,HISx,HISy,message[1],strlen(message[1]));
  Sec2Clock(str, i);  
  if (Time1 == 0) str[2] = ' ';
  XDrawString(d2,win2[0],gc2,HIStx,HISty,str,strlen(str));
  XFlush(d2);
}

Sec2Clock(s,t)
int t;
char *s;
{
  if (t >= 600) s[0] = '0'+(t/60)/10; else s[0] = ' ';
  if (t >= 60) s[1] = '0'+(t/60)%10; else s[1] = ' ';
  s[2] = ':';
  if (t >= 10) s[3] = '0'+(t%60)/10; else s[3] = ' ';
  if (t >= 0) s[4] = '0'+(t%60)%10; else s[4] = ' ';
  s[5] = '\0';
}

PrintTime1(n)
int n;
{
  char str[10];
  Sec2Clock(str, n);
  if (Time1 == 0) str[2] = ' ';
  XFillRectangle(d,win[0],gcb,FILLYOUx,FILLYOUy,70,21);
  XDrawString(d,win[0],gc,YOURStx,YOURSty,str,strlen(str));
  XFlush(d);
  XFillRectangle(d2,win2[0],gcb2,FILLHISx,FILLHISy,70,21);
  XDrawString(d2,win2[0],gc2,HIStx,HISty,str,strlen(str));
  XFlush(d2);
}

PrintTime2(n)
int n;
{
  char str[10];
  Sec2Clock(str, n);
  if (Time2 == 0) str[2] = ' ';
  XFillRectangle(d,win[0],gcb,FILLHISx,FILLHISy,70,21);
  XDrawString(d,win[0],gc,HIStx,HISty,str,strlen(str));
  XFlush(d);
  XFillRectangle(d2,win2[0],gcb2,FILLYOUx,FILLYOUy,70,21);
  XDrawString(d2,win2[0],gc2,YOURStx,YOURSty,str,strlen(str));
  XFlush(d2);
}

AskTime()
{
  int i;
  if (atoi(TIME) > 60) i = 60;
  else if (atoi(TIME) < 0) i = 10;
  else i = atoi(TIME);
  Time1 = i*60;
  if (atoi(TIME1) > 60) i = 60;
  else if (atoi(TIME1) < 0) i = 10;
  else i = atoi(TIME1);
  Time2 = i*60;
  if (atoi(TIME2) > 60) i = 60;
  else if (atoi(TIME2) < 0) i = 30;
  else i = atoi(TIME2);
  TimeMode1 = i;
  if (atoi(TIME3) > 60) i = 60;
  else if (atoi(TIME3) < 0) i = 30;
  else i = atoi(TIME3);
  TimeMode2 = i;
}

MattaExpose1()
{
  Mt++;
  signal(SIGALRM, SIG_IGN);
  while (XEventsQueued(d, QueuedAfterFlush) != 0) {
    XNextEvent(d, &event);
    switch(event.type) {
     case Expose:
      DrawLine();
      WindowPick(koma);
      ExposePrintMessage(14);
      ExposePrintTime1();
      break;
    }
  } 
  alarm(1);
  signal(SIGALRM,MattaExpose1);
  return TRUE;
}

MattaExpose2()
{
  Mt++;
  signal(SIGALRM, SIG_IGN);
  while (XEventsQueued(d2, QueuedAfterFlush) != 0) {
    XNextEvent(d2, &event2);
    switch(event2.type) {
     case Expose:
      DrawLine2();
      WindowPick(koma);
      ExposePrintMessage2(14);
      ExposePrintTime2();
      break;
    }
  } 
  alarm(1);
  signal(SIGALRM,MattaExpose2);
  return TRUE;
}
