#include "main.h"
#include "komabitmaps"

static char *message[17] = {
                    "YOUR  TURN","HIS  TURN","YOU  WIN","YOU  LOSE",
                    "Sorry,  but you can't.","Want to change this Koma?",
                    "Now saving this state","He is saying   'Matta'.",
                    "Matta","You give up?",
                    "You gave up.     YOU  LOSE","He gave up.     YOU  WIN",
                    "Tsumi.     YOU  WIN","Tsumi.     YOU  LOSE",
                    "Now asking him.",
                    "Time out.     YOU  WIN","Time out.     YOU  LOSE"};

MoveMochigoma(m,x,y)
int m,x,y;
{
  int w = Mochigoma1W[m], i,t;
  XMoveWindow( d,  win[w], 175+x*50,  45+y*50);
  XMoveWindow(d2, win2[w],575-x*50, 445-y*50);
  Board[y][x]  = Mochigoma1[m];
  BoardW[y][x] = w;

  m1--;
  for (i=m;i<m1;i++) {
    Mochigoma1[i] = Mochigoma1[i+1];
    Mochigoma1W[i] = Mochigoma1W[i+1];
  }
  Mochigoma1[m1] = Mochigoma1W[m1] = 0;

  if (m1 <= 18) t = m1;
    else t = 18;
  for (i=m;i<t;i++) {
    w = Mochigoma1W[i];
    XMoveWindow( d,  win[w], i/6*50+635, i%6*50+195);
    XMoveWindow(d2, win2[w], 115-i/6*50, 295-i%6*50);
  }
  XFlush(d);
  XFlush(d2);
}

MoveMochigoma2(m,x,y)
int m,x,y;
{
  int w = Mochigoma2W[m], i,t;
  XMoveWindow( d,  win[w], 175+x*50,  45+y*50);
  XMoveWindow(d2, win2[w],575-x*50, 445-y*50);
  Board[y][x]  = Mochigoma2[m];
  BoardW[y][x] = w;

  m2--;
  for (i=m;i<m2;i++) {
    Mochigoma2[i] = Mochigoma2[i+1];
    Mochigoma2W[i] = Mochigoma2W[i+1];
  }
  Mochigoma2[m2] = Mochigoma2W[m2] = 0;

  if (m2 <= 18) t = m2;
    else t = 18;
  for (i=m;i<t;i++) {  
    w = Mochigoma2W[i];
    XMoveWindow( d,  win[w], 115-i/6*50, 295-i%6*50);
    XMoveWindow(d2, win2[w], i/6*50+635, i%6*50+195);
  }
  XFlush(d);
  XFlush(d2);
}

MoveKoma(x0,y0,x,y)
int x0,y0,x,y;
{
  int b = BoardW[y0][x0];
  XMoveWindow( d,  win[b], 175+x*50,  45+y*50);
  XMoveWindow(d2, win2[b],575-x*50, 445-y*50);
  if (CheckEnemy(x,y)) GetEnemy(x,y);
  if (CheckNari(x0,y0,x,y)) NariKoma(x0,y0);
  Board[y][x] = Board[y0][x0];
  BoardW[y][x] = b;
  Board[y0][x0] = BoardW[y0][x0] = 0;
  XFlush(d);
  XFlush(d2);
}

GetEnemy(x,y)
int x,y;
{
  int n = BoardW[y][x];
  char *bits, *bits2;
  switch(Board[y][x]%10){
    case FU1:
      bits = fu_bits;
      bits2 = fu2_bits;
      break;
    case GYO1:
      bits = yari_bits;
      bits2 = yari2_bits;
      break;
    case KEI1:
      bits = kei_bits;
      bits2 = kei2_bits;
      break;
    case GIN1:
      bits = gin_bits;
      bits2 = gin2_bits;
      break;
    case KAKU1:
      bits = kaku_bits;
      bits2 = kaku2_bits;
      break;
    case HISHA1:
      bits = hisha_bits;
      bits2 = hisha2_bits;
      break;
    case KIN1:
      bits = kin_bits;
      bits2 = kin2_bits;
      break;
  }
  Mochigoma1[m1] = Board[y][x]%10;
  Mochigoma1W[m1] = n;
  Board[y][x] = BoardW[y][x] = 0;
  if (m1 < 18) {
    XMoveWindow(d ,  win[n], 635+m1/6*50, 195+m1%6*50);
    XMoveWindow(d2, win2[n], 115-m1/6*50, 295-m1%6*50);
  }
  else {
    XMoveWindow( d,  win[n], 1000, 0);
    XMoveWindow(d2, win2[n], 1000, 0);
  }
  m1++;
  ChangeKoma(n,bits,bits2);
}

CheckEnemy(x,y)
int x,y;
{
  if (Board[y][x] == OO2) {
    XMoveWindow(d , win[BoardW[y][x]], 1000, 0);
    XMoveWindow(d2, win2[BoardW[y][x]], 1000, 0);
    Win(1);
  }
  else if (Board[y][x] > 20) return TRUE;
  else return FALSE;
}

NariKoma(x0,y0)
int x0,y0;
{
  int n = BoardW[y0][x0];
  char *bits, *bits2;
  switch(Board[y0][x0]){
    case FU1:
      bits = to_bits;
      bits2 = to2_bits;
      break;
    case GYO1:
      bits = nyari_bits;
      bits2 = nyari2_bits;
      break;
    case KEI1:
      bits = narikei_bits;
      bits2 = narikei2_bits;
      break;
    case GIN1:
      bits = narigin_bits;
      bits2 = narigin2_bits;
      break;
    case KAKU1:
      bits = uma_bits;
      bits2 = uma2_bits;
      break;
    case HISHA1:
      bits = ryu_bits;
      bits2 = ryu2_bits;
      break;
  }
  ChangeKoma(n,bits,bits2);
  Board[y0][x0] = Board[y0][x0] + 10;
}

ChangeKoma(n,bits,bits2)
int n;
char *bits,*bits2;
{
  pixmap = XCreatePixmapFromBitmapData( d, win[n],
               bits, 40, 40, fg, bg, dd);
  XSetWindowBackgroundPixmap(d, win[n], pixmap);
  XClearWindow(d, win[n]);
  pixmap = XCreatePixmapFromBitmapData(d2, win2[n],
               bits2, 40, 40, fg2, bg2, dd2);
  XSetWindowBackgroundPixmap(d2, win2[n], pixmap);
  XClearWindow(d2, win2[n]);
}

CheckNari(x0,y0,x,y)
int x0,y0,x,y;
{
  if ((y == 0) && (Board[y0][x0] < 3) ||
      (y < 2) && (Board[y0][x0] == 3)) return TRUE;
  if ((y < 3 || y0 < 3) && (Board[y0][x0] < 7))
    if (AskNari(x0,y0)) return TRUE;
  return FALSE;
}

AskNari(x0,y0)
int x0,y0;
{
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;
  PrintMessage(5);
  XMoveWindow( d,  win[41], 650,  5);
  XMoveWindow( d,  win[42], 710,  5);
  XQueryPointer( d, win[0], &root, &child, &rx, &ry, &wx, &wy, &mask);
  XWarpPointer( d, None, win[41], 0, 0, 0, 0, 25, 25);
  while(True){
    XNextEvent(d, &event);
    switch(event.type){
      case ButtonPress:
        if (win[41] == event.xany.window || win[42] == event.xany.window) 
          goto End;
	break;
      case Expose:
       DrawLine();
       ExposePrintMessage(5);
       ExposePrintTime1();
       break;
    }
  }
  End:
  XMoveWindow( d,  win[41], 1000,  0);
  XMoveWindow( d,  win[42], 1000,  0);
  XWarpPointer( d, None, root, 0, 0, 0, 0, rx, ry);
  if (win[41] == event.xany.window) return TRUE;
  else return FALSE;
}

MoveKoma2(x0,y0,x,y)
int x0,y0,x,y;
{
  int b = BoardW[y0][x0];
  XMoveWindow( d,  win[b], 175+x*50,  45+y*50);
  XMoveWindow(d2, win2[b],575-x*50, 445-y*50);
  if (CheckEnemy2(x,y)) GetEnemy2(x,y);
  if (CheckNari2(x0,y0,x,y)) NariKoma2(x0,y0);
  Board[y][x] = Board[y0][x0];
  BoardW[y][x] = b;
  Board[y0][x0] = BoardW[y0][x0] = 0;
  XFlush(d);
  XFlush(d2);
}

GetEnemy2(x,y)
int x,y;
{
  int n = BoardW[y][x];
  char *bits, *bits2;
  switch(Board[y][x]%10){
    case FU1:
      bits = fu2_bits;
      bits2 = fu_bits;
      break;
    case GYO1:
      bits = yari2_bits;
      bits2 = yari_bits;
      break;
    case KEI1:
      bits = kei2_bits;
      bits2 = kei_bits;
      break;
    case GIN1:
      bits = gin2_bits;
      bits2 = gin_bits;
      break;
    case KAKU1:
      bits = kaku2_bits;
      bits2 = kaku_bits;
      break;
    case HISHA1:
      bits = hisha2_bits;
      bits2 = hisha_bits;
      break;
    case KIN1:
      bits = kin2_bits;
      bits2 = kin_bits;
      break;
  }
  Mochigoma2[m2] = Board[y][x]%10 + 20;
  Mochigoma2W[m2] = n;
  Board[y][x] = BoardW[y][x] = 0;
  if (m2 < 18) {
    XMoveWindow(d ,  win[n], 115-m2/6*50, 295-m2%6*50);
    XMoveWindow(d2, win2[n], 635+m2/6*50, 195+m2%6*50);
  }
  else {
    XMoveWindow( d,  win[n], 1000, 0);
    XMoveWindow(d2, win2[n], 1000, 0);
  }
  m2++;
  ChangeKoma(n,bits,bits2);
}

CheckEnemy2(x,y)
int x,y;
{
  if (Board[y][x] == OO1) {
    XMoveWindow(d , win[BoardW[y][x]], 1000, 0);
    XMoveWindow(d2, win2[BoardW[y][x]], 1000, 0);
    Win(2);
  }
  else if (Board[y][x] < 20 && Board[y][x] > 0) return TRUE;
  else return FALSE;
}

NariKoma2(x0,y0)
int x0,y0;
{
  int n = BoardW[y0][x0];
  char *bits, *bits2;
  switch(Board[y0][x0]){
    case FU2:
      bits = to2_bits;
      bits2 = to_bits;
      break;
    case GYO2:
      bits = nyari2_bits;
      bits2 = nyari_bits;
      break;
    case KEI2:
      bits = narikei2_bits;
      bits2 = narikei_bits;
      break;
    case GIN2:
      bits = narigin2_bits;
      bits2 = narigin_bits;
      break;
    case KAKU2:
      bits = uma2_bits;
      bits2 = uma_bits;
      break;
    case HISHA2:
      bits = ryu2_bits;
      bits2 = ryu_bits;
      break;
  }
  ChangeKoma(n,bits,bits2);
  Board[y0][x0] = Board[y0][x0] + 10;
}

CheckNari2(x0,y0,x,y)
int x0,y0,x,y;
{
  if ((y == 8) && (Board[y0][x0] < 23) ||
      (y > 6) && (Board[y0][x0] == 23)) return TRUE;
  if ((y > 5 || y0 > 5) && (Board[y0][x0] < 27))
    if (AskNari2()) return TRUE;
  return FALSE;
}

AskNari2()
{
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;
  PrintMessage2(5);
  XMoveWindow(d2,  win2[41], 650,  5);
  XMoveWindow(d2,  win2[42], 710,  5);
  XQueryPointer( d2, win2[0], &root, &child, &rx, &ry, &wx, &wy, &mask);
  XWarpPointer( d2, None, win2[41], 0, 0, 0, 0, 25, 25);
  while(True){
    XNextEvent(d2, &event2);
    switch(event2.type){
      case ButtonPress:
        if (win2[41] == event2.xany.window || win2[42] == event2.xany.window)
          goto End2;
      case Expose:
       DrawLine2();
       ExposePrintMessage2(5);
       ExposePrintTime2();
       break;
    }
  }
  End2:
  XMoveWindow(d2,  win2[41], 1000,  0);
  XMoveWindow(d2,  win2[42], 1000,  0);
  XWarpPointer(d2, None, root, 0, 0, 0, 0, rx, ry);
  if (win2[41] == event2.xany.window) return TRUE;
  else return FALSE;
}

PrintMessage(n)
int n;
{
  int x,y;
  XFillRectangle(d,win[0],gcb,FILLMESx,FILLMESy,450,26);
  x = (MESx - XTextWidth(font,message[n],strlen(message[n]))) / 2;
  y = MESy;
  XDrawString(d,win[0],gc,x,y,message[n],strlen(message[n]));
  XFlush(d);
}

PrintMessage2(n)
int n;
{
  int x,y;
  XFillRectangle(d2,win2[0],gcb2,FILLMESx,FILLMESy,450,26);
  x = (MESx - XTextWidth(font2,message[n],strlen(message[n]))) / 2;
  y = MESy;
  XDrawString(d2,win2[0],gc2,x,y,message[n],strlen(message[n]));
  XFlush(d2);
}

ExposePrintMessage(n)
int n;
{
  int x,y;
  x = (MESx - XTextWidth(font,message[n],strlen(message[n]))) / 2;
  y = MESy;
  XDrawString(d,win[0],gc,x,y,message[n],strlen(message[n]));
  XFlush(d);
}

ExposePrintMessage2(n)
int n;
{
  int x,y;
  x = (MESx - XTextWidth(font2,message[n],strlen(message[n]))) / 2;
  y = MESy;
  XDrawString(d2,win2[0],gc2,x,y,message[n],strlen(message[n]));
  XFlush(d2);
}

WindowPick(n)
int n;
{
  int i,x,y;
  for (i=0;i<81;i++)
    if (BoardW[i/9][i%9] == n) break;
 if (i != 81) { 
  x = 50*(i%9); y = 50*(i/9);
  XDrawLine(d ,win[0], gc, 171+x, 41+y, 219+x, 41+y);
  XDrawLine(d ,win[0], gc, 171+x, 41+y, 171+x, 89+y);
  XDrawLine(d ,win[0], gc, 219+x, 41+y, 219+x, 89+y);
  XDrawLine(d ,win[0], gc, 171+x, 89+y, 219+x, 89+y);
  XDrawLine(d ,win[0], gc, 172+x, 42+y, 218+x, 42+y);
  XDrawLine(d ,win[0], gc, 172+x, 42+y, 172+x, 88+y);
  XDrawLine(d ,win[0], gc, 218+x, 42+y, 218+x, 88+y);
  XDrawLine(d ,win[0], gc, 172+x, 88+y, 218+x, 88+y);
  /*  XSetWindowBorderWidth(d,win[n], 2);*/
  /*  XFlush(d);*/
  x = 50*(8-i%9); y = 50*(8-i/9);
  XDrawLine(d2,win2[0],gc2, 171+x, 41+y, 219+x, 41+y);
  XDrawLine(d2,win2[0],gc2, 171+x, 41+y, 171+x, 89+y);
  XDrawLine(d2,win2[0],gc2, 219+x, 41+y, 219+x, 89+y);
  XDrawLine(d2,win2[0],gc2, 171+x, 89+y, 219+x, 89+y);
  XDrawLine(d2,win2[0],gc2, 172+x, 42+y, 218+x, 42+y);
  XDrawLine(d2,win2[0],gc2, 172+x, 42+y, 172+x, 88+y);
  XDrawLine(d2,win2[0],gc2, 218+x, 42+y, 218+x, 88+y);
  XDrawLine(d2,win2[0],gc2, 172+x, 88+y, 218+x, 88+y);
  /*  XSetWindowBorderWidth(d2,win2[n], 2);*/
  /*  XFlush(d2);*/
  return;
 }
  for (i=0;i<40;i++)
    if (Mochigoma1W[i] == n) break;
 if (i !=  40) {
  x = 50*(i/6); y = 50*(i%6);
  XDrawLine(d ,win[0], gc, 631+x, 191+y, 679+x, 191+y);
  XDrawLine(d ,win[0], gc, 631+x, 191+y, 631+x, 239+y);
  XDrawLine(d ,win[0], gc, 679+x, 191+y, 679+x, 239+y);
  XDrawLine(d ,win[0], gc, 631+x, 239+y, 679+x, 239+y);
  XDrawLine(d ,win[0], gc, 632+x, 192+y, 678+x, 192+y);
  XDrawLine(d ,win[0], gc, 632+x, 192+y, 632+x, 238+y);
  XDrawLine(d ,win[0], gc, 678+x, 192+y, 678+x, 238+y);
  XDrawLine(d ,win[0], gc, 632+x, 238+y, 678+x, 238+y);
  x = 50*(2-i/6); y = 50*(5-i%6);
  XDrawLine(d2,win2[0],gc2, 11+x, 41+y, 59+x, 41+y);
  XDrawLine(d2,win2[0],gc2, 11+x, 41+y, 11+x, 89+y);
  XDrawLine(d2,win2[0],gc2, 59+x, 41+y, 59+x, 89+y);
  XDrawLine(d2,win2[0],gc2, 11+x, 89+y, 59+x, 89+y);
  XDrawLine(d2,win2[0],gc2, 12+x, 42+y, 58+x, 42+y);
  XDrawLine(d2,win2[0],gc2, 12+x, 42+y, 12+x, 88+y);
  XDrawLine(d2,win2[0],gc2, 58+x, 42+y, 58+x, 88+y);
  XDrawLine(d2,win2[0],gc2, 12+x, 88+y, 58+x, 88+y);
  return;
 }
  for (i=0;i<40;i++)
    if (Mochigoma2W[i] == n) break;
 if (i !=  40) {
  x = 50*(2-i/6); y = 50*(5-i%6);
  XDrawLine(d ,win[0], gc, 11+x, 41+y, 59+x, 41+y);
  XDrawLine(d ,win[0], gc, 11+x, 41+y, 11+x, 89+y);
  XDrawLine(d ,win[0], gc, 59+x, 41+y, 59+x, 89+y);
  XDrawLine(d ,win[0], gc, 11+x, 89+y, 59+x, 89+y);
  XDrawLine(d ,win[0], gc, 12+x, 42+y, 58+x, 42+y);
  XDrawLine(d ,win[0], gc, 12+x, 42+y, 12+x, 88+y);
  XDrawLine(d ,win[0], gc, 58+x, 42+y, 58+x, 88+y);
  XDrawLine(d ,win[0], gc, 12+x, 88+y, 58+x, 88+y);
  x = 50*(i/6); y = 50*(i%6);
  XDrawLine(d2,win2[0],gc2, 631+x, 191+y, 679+x, 191+y);
  XDrawLine(d2,win2[0],gc2, 631+x, 191+y, 631+x, 239+y);
  XDrawLine(d2,win2[0],gc2, 679+x, 191+y, 679+x, 239+y);
  XDrawLine(d2,win2[0],gc2, 631+x, 239+y, 679+x, 239+y);
  XDrawLine(d2,win2[0],gc2, 632+x, 192+y, 678+x, 192+y);
  XDrawLine(d2,win2[0],gc2, 632+x, 192+y, 632+x, 238+y);
  XDrawLine(d2,win2[0],gc2, 678+x, 192+y, 678+x, 238+y);
  XDrawLine(d2,win2[0],gc2, 632+x, 238+y, 678+x, 238+y);
  return;
 }
}

WindowBorderErase(n)
int n;
{
 int i,x,y;
 koma = 99;
 for (i=0;i<81;i++)
   if (BoardW[i/9][i%9] == n) break;
 if (i != 81) {
  x = 50*(i%9); y = 50*(i/9);
  XDrawLine(d ,win[0], gcb, 171+x, 41+y, 219+x, 41+y);
  XDrawLine(d ,win[0], gcb, 171+x, 41+y, 171+x, 89+y);
  XDrawLine(d ,win[0], gcb, 219+x, 41+y, 219+x, 89+y);
  XDrawLine(d ,win[0], gcb, 171+x, 89+y, 219+x, 89+y);
  XDrawLine(d ,win[0], gcb, 172+x, 42+y, 218+x, 42+y);
  XDrawLine(d ,win[0], gcb, 172+x, 42+y, 172+x, 88+y);
  XDrawLine(d ,win[0], gcb, 218+x, 42+y, 218+x, 88+y);
  XDrawLine(d ,win[0], gcb, 172+x, 88+y, 218+x, 88+y);
  /*  XSetWindowBorderWidth(d ,win[n], 0);*/
  /*  XFlush(d);*/
  x = 50*(8-i%9); y = 50*(8-i/9);
  XDrawLine(d2,win2[0],gcb2, 171+x, 41+y, 219+x, 41+y);
  XDrawLine(d2,win2[0],gcb2, 171+x, 41+y, 171+x, 89+y);
  XDrawLine(d2,win2[0],gcb2, 219+x, 41+y, 219+x, 89+y);
  XDrawLine(d2,win2[0],gcb2, 171+x, 89+y, 219+x, 89+y);
  XDrawLine(d2,win2[0],gcb2, 172+x, 42+y, 218+x, 42+y);
  XDrawLine(d2,win2[0],gcb2, 172+x, 42+y, 172+x, 88+y);
  XDrawLine(d2,win2[0],gcb2, 218+x, 42+y, 218+x, 88+y);
  XDrawLine(d2,win2[0],gcb2, 172+x, 88+y, 218+x, 88+y);
  /*  XSetWindowBorderWidth(d2,win2[n], 0);*/
  /*  XFlush(d2);*/
  return;
 }
 for (i=0;i<40;i++)
   if (Mochigoma1W[i] == n) break;
 if (i !=  40) { 
  x = 50*(i/6); y = 50*(i%6);
  XDrawLine(d ,win[0],gcb, 631+x, 191+y, 679+x, 191+y);
  XDrawLine(d ,win[0],gcb, 631+x, 191+y, 631+x, 239+y);
  XDrawLine(d ,win[0],gcb, 679+x, 191+y, 679+x, 239+y);
  XDrawLine(d ,win[0],gcb, 631+x, 239+y, 679+x, 239+y);
  XDrawLine(d ,win[0],gcb, 632+x, 192+y, 678+x, 192+y);
  XDrawLine(d ,win[0],gcb, 632+x, 192+y, 632+x, 238+y);
  XDrawLine(d ,win[0],gcb, 678+x, 192+y, 678+x, 238+y);
  XDrawLine(d ,win[0],gcb, 632+x, 238+y, 678+x, 238+y);
  x = 50*(2-i/6); y = 50*(5-i%6);
  XDrawLine(d2,win2[0],gcb2, 11+x, 41+y, 59+x, 41+y);
  XDrawLine(d2,win2[0],gcb2, 11+x, 41+y, 11+x, 89+y);
  XDrawLine(d2,win2[0],gcb2, 59+x, 41+y, 59+x, 89+y);
  XDrawLine(d2,win2[0],gcb2, 11+x, 89+y, 59+x, 89+y);
  XDrawLine(d2,win2[0],gcb2, 12+x, 42+y, 58+x, 42+y);
  XDrawLine(d2,win2[0],gcb2, 12+x, 42+y, 12+x, 88+y);
  XDrawLine(d2,win2[0],gcb2, 58+x, 42+y, 58+x, 88+y);
  XDrawLine(d2,win2[0],gcb2, 12+x, 88+y, 58+x, 88+y);
  return;
 }
 for (i=0;i<40;i++)
   if (Mochigoma2W[i] == n) break;
 if (i !=  40) {
  x = 50*(2-i/6); y = 50*(5-i%6);
  XDrawLine(d ,win[0],gcb, 11+x, 41+y, 59+x, 41+y);
  XDrawLine(d ,win[0],gcb, 11+x, 41+y, 11+x, 89+y);
  XDrawLine(d ,win[0],gcb, 59+x, 41+y, 59+x, 89+y);
  XDrawLine(d ,win[0],gcb, 11+x, 89+y, 59+x, 89+y);
  XDrawLine(d ,win[0],gcb, 12+x, 42+y, 58+x, 42+y);
  XDrawLine(d ,win[0],gcb, 12+x, 42+y, 12+x, 88+y);
  XDrawLine(d ,win[0],gcb, 58+x, 42+y, 58+x, 88+y);
  XDrawLine(d ,win[0],gcb, 12+x, 88+y, 58+x, 88+y);
  x = 50*(i/6); y = 50*(i%6);
  XDrawLine(d2,win2[0],gcb2, 631+x, 191+y, 679+x, 191+y);
  XDrawLine(d2,win2[0],gcb2, 631+x, 191+y, 631+x, 239+y);
  XDrawLine(d2,win2[0],gcb2, 679+x, 191+y, 679+x, 239+y);
  XDrawLine(d2,win2[0],gcb2, 631+x, 239+y, 679+x, 239+y);
  XDrawLine(d2,win2[0],gcb2, 632+x, 192+y, 678+x, 192+y);
  XDrawLine(d2,win2[0],gcb2, 632+x, 192+y, 632+x, 238+y);
  XDrawLine(d2,win2[0],gcb2, 678+x, 192+y, 678+x, 238+y);
  XDrawLine(d2,win2[0],gcb2, 632+x, 238+y, 678+x, 238+y);
  return;
 }
}


